Page MenuHomePhabricator

Add Acceptance Criteria/Checklist feature to Phabricator tasks
Closed, DeclinedPublic4 Estimated Story Points

Description

In Trello, you can add a checklist to any card/task. We use this for keeping track of which acceptance criteria have been completed. When an acceptance criteria has been completed, the checkbox next to it is clicked, which causes the list item to become grey and struckthru. It also changes the "Percent complete" reading above the checklist.

This is what we have now:

Event Timeline

kaldari created this task.Nov 6 2014, 11:24 PM
kaldari raised the priority of this task from to Needs Triage.
kaldari updated the task description. (Show Details)
kaldari added a project: Phabricator.
kaldari changed Security from none to None.
kaldari added subscribers: kaldari, Jdlrobson.
Qgil triaged this task as Lowest priority.Nov 6 2014, 11:37 PM
Qgil edited projects, added Phabricator (Upstream); removed Phabricator.
Qgil added a subtask: T116: Checklists.
Qgil updated the task description. (Show Details)Nov 6 2014, 11:46 PM
Qgil mentioned this in T116: Checklists.
Qgil added a subscriber: Qgil.

Thanks for following up our conversation with this new task. I have edited the description to reflect what we have today. You can click edit to see the formatting used.

Considering that you can reproduce the UI (even with more manual work, and considering that the "percentage complete" is just an illusion, can we consider this task Resolved as 'good enough' for stock Phabricator?

One additional option is to talk with @Christopher to see whether this functionality could be added to the Sprint extension, and therefore be available only for tasks joining sprints (which seems to be the desire already). A problem might be to offer arbitrary fields for the checklist, as opposed to a global option for all sprint tasks.

Christopher edited a custom field.Dec 11 2014, 8:12 AM

Since this task has been marked as a blocker for T832: Migration of the Design team to Phabricator, it would be useful to know exactly what features are you missing compared to the formatting we have now (see the description).

Qgil raised the priority of this task from Lowest to Low.Dec 17 2014, 10:42 AM
Qgil added a comment.Dec 23 2014, 6:56 PM
In T1141#852680, @Qgil wrote:

Since this task has been marked as a blocker for T832: Migration of the Design team to Phabricator, it would be useful to know exactly what features are you missing compared to the formatting we have now (see the description).

See also this task upstream: Support Task List syntax in remarkup. It includes some reasoning from the maintainers about why they have no current plans to bring checklists further in Phabricator.

@Qgil we'd just like checklists to work like trello's e.g. you can interact with them without editing the text object they are in.

Qgil added a comment.Dec 29 2014, 11:26 AM

I understand the difference, but do you really think such difference is a blocker for the migration of your team?

​for us to completely abandon Trello for internal planning purposes, yes.
We should also check with Analytics and Mobile web as they use these
features extensively. Designers will move to Phab with their dev teams, so
its more of a question to those teams.

*Jared Zimmerman * \\ Director of User Experience \\ Wikimedia Foundation

M +1 415 609 4043 \\ @Jaredzimmerman http://loo.ms/g0

CCing Mobile Web and Analytics (should be Analytics Research & Data but the project is set to private and I can't even CC them).

I checked with the Analytics Research & Data team. For them, implementing checklists like Trello, while not a blocker for moving to Phab, is a high priority request.

Is someone actively working on this functionality?

mmodell added a subscriber: mmodell.Jan 6 2015, 6:35 PM

@ggellerman: no, and there isn't a dedicated team working on phabricator feature requests. Features like this are unlikely to happen without someone volunteering their time to implement it or a team willing to donate some development resources to the task.

Qgil added a comment.Jan 6 2015, 7:26 PM

@mmodell, I don't think we can ask teams or anybody to provide development work for the features they request. What we can do is to ask the right questions and prioritize accordingly considering all the rest of work that we want to do.

@ggellerman, is the Analytics Research & Data team aware o the possibility to create and maintain checklists at the task description, being this feature request really about the convenience of updating such checklists without having to edit them manually?

Implementing a new object for checklists is not in upstream's plans, and we are not considering working in an extension to provide this feature, because it would imply a good amount of development and maintenance resources. While the current markup for checklists is no equivalent for Trello's checklists, and it is not so convenient to maintain, I think it does provide the basics.

@Qgil I reviewed this request with the R&D team and given that they rely extensively on checklists for their work, this remains a high priority. The checklist markup option is a temporary solution but not the feature they are looking for. In Trello, the card subtasks show up as completed as soon as they are all selected, there is a visual progress indicator of how many subtasks are pending in the board view and it's easy to turn a subtask from a checklist into a standalone card: these are features that are not supported by the checklist markup in Phab's task description.

Qgil added a comment.Jan 16 2015, 10:38 AM

Realistically speaking, upstream has said that they are not interested in creating a new object for these checklists, and we don't think we should put our resources in developing a maintaining an extension to emulate Trello's current behavior. Most migrations imply some loss of functionality in exchange of some gain in other features.

I think we need to be bold here and resolve this task as Declined. Otherwise we will be keeping false expectations.

Qgil closed this task as Declined.Feb 4 2015, 8:22 PM
Qgil claimed this task.
In T1141#981463, @Qgil wrote:

I think we need to be bold here and resolve this task as Declined. Otherwise we will be keeping false expectations.

Resolving accordingly.

Apart from existing markup, there is also Unicode: ☐☑☒. Just writing down the obvious - of course there is no integration with making strings grey or changing percentage values.

Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptMay 23 2016, 6:05 PM